GEGELATI

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
Instructions::Set Class Reference

Class for storing a set of Instruction. More...

`#include <set.h>`

## Public Member Functions
| Set ()
| Default constructor.
bool | add (const Instruction &instruction)
| Add an instruction to the set.
unsigned int | getNbInstructions () const
| Get the number of Instruction contained in the Set.
const Instruction & | getInstruction (const uint64_t i) const
| Get the Instruction at the given index i in the Set.
unsigned int | getMaxNbOperands () const
| Get the maximum number of operands for Instruction currently contained in the Set.

## Protected Attributes
std::vector< std::reference_wrapper< const Instruction > > | instructions
| Ordered container of the Instruction of the set.

## Detailed Description

Class for storing a set of Instruction.

Together with storage capabilities, this class provide methods to compute useful information on the ordered set of Instruction it contains.

## Constructor & Destructor Documentation

## ◆ Set()

Instructions::Set::Set | ( |  | ) |
| inline

Default constructor.

This constructor simply creates an empty list of instructions.

## Member Function Documentation

## ◆ add()

bool Instructions::Set::add | ( | const Instruction & | instruction | ) |

Add an instruction to the set.

Instruction added to the set are stored and indexed in the order in which they are added.

Parameters

  [in] | instruction | the Instruction to be added to the Set.

Returns
  true if the instruction was successfully added.

Copyright or © or Copr. IETR/INSA - Rennes (2019 - 2025) :

Karol Desnos kdesn.nosp@m.os@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2019) Nicolas Sourbier nsour.nosp@m.bie@.nosp@m.insa-.nosp@m.renn.nosp@m.es.fr (2020) Quentin Vacher qvach.nosp@m.er@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2025)

GEGELATI is an open-source reinforcement learning framework for training artificial intelligence based on Tangled Program Graphs (TPGs).

This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software. You can use, modify and/ or redistribute the software under the terms of the CeCILL-C license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".

As a counterpart to the access to the source code and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty and the software's author, the holder of the economic rights, and the successive licensors have only limited liability.

In this respect, the user's attention is drawn to the risks associated with loading, using, modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or data to be ensured and, more generally, to use and operate it in the same conditions as regards security.

The fact that you are presently reading this means that you have had knowledge of the CeCILL-C license and that you accept its terms.

## ◆ getInstruction()

const Instructions::Instruction & Instructions::Set::getInstruction | ( | const uint64_t | i | ) | const

Get the Instruction at the given index i in the Set.

Parameters

  [in] | i | the unsigned integer index of the Instruction to retrieve.

Exceptions

  std::out_of_range | if the given index exceeds the number of Instruction in the Set.

Returns
  a reference to the Instruction at the given index.

## ◆ getMaxNbOperands()

unsigned int Instructions::Set::getMaxNbOperands | ( |  | ) | const

Get the maximum number of operands for Instruction currently contained in the Set.

Returns
  the unsigned int value corresponding to the largest number of operands needed to execute an Instruction in the Set.

## ◆ getNbInstructions()

unsigned int Instructions::Set::getNbInstructions | ( |  | ) | const

Get the number of Instruction contained in the Set.

Returns
  the int corresponding to the number of Instruction in the Set.

The documentation for this class was generated from the following files:

- D:/a/gegelati/gegelati/gegelatilib/include/instructions/set.h
- D:/a/gegelati/gegelati/gegelatilib/src/instructions/set.cpp